<?php
namespace Teknisa\FIS\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;

class Ger99100RelacionamentoImpostosFiscaisController {

	protected $relacionamentoImpostosFiscaisService;

	public function __construct(\Teknisa\FIS\Services\Ger99100RelacionamentoImpostosFiscaisService $relacionamentoImpostosFiscaisService) {
		$this->relacionamentoImpostosFiscaisService = $relacionamentoImpostosFiscaisService;
	}

	public function removeNfeRelationship(DTO\Request\Row $request, DTO\Response $response) {
		try {
			$row = $request->getRow();
			$this->relacionamentoImpostosFiscaisService->removeNfeRelationship($row);
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
		}
	}

	public function saveNfeRelationship(DTO\Request\Row $request, DTO\Response $response) {
		try {
			$row = $request->getRow();
			$this->relacionamentoImpostosFiscaisService->saveNfeRelationship($row);
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
		}
	}
	public function incluirImpostos(DTO\Request\Row $request, DTO\Response $response) {
		try {
			$this->relacionamentoImpostosFiscaisService->incluirImpostos();
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
		}
	}

	public function saveXmlRelationship(DTO\Request\Row $request, DTO\Response $response) {
		try {
			$row = $request->getRow();
			$this->relacionamentoImpostosFiscaisService->saveXmlRelationship($row);
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
		}
	}

}