/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_EQPT                                                     */
/* Tabela : EQUIPETRAB                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_EQPT'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_EQPT
GO

CREATE TRIGGER DTULTATU_EQPT
ON EQUIPETRAB
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'EQUIPETRAB', null, 'CDEQUIPETRAB='+ CDEQUIPETRAB+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE EQUIPETRAB
      SET DTULTATUEQPT = GETDATE()
      FROM INSERTED;
   END;
END;
GO

