IF EXISTS(SELECT NAME
            FROM SYSOBJECTS
           WHERE NAME = 'CTB_BCO_TRANSF' AND TYPE = 'P')
   DROP PROCEDURE CTB_BCO_TRANSF
GO


CREATE PROCEDURE CTB_BCO_TRANSF (
  @P_NRLANCCTBTEMP VARCHAR(12),
  @P_NRTRANBANC    VARCHAR(10),
  @P_CDEMPRESA     VARCHAR(02),
  @P_DATA          DATE,
  @P_NRLANCCTB     VARCHAR(12) OUTPUT)
AS
  DECLARE @V_DSHISTLANC    VARCHAR(200);
  DECLARE @V_NRLANCTEMP    VARCHAR(20);
  DECLARE @V_DTLANCCTBTEMP DATE;
  DECLARE @V_PARTIDA       INT;
  DECLARE @V_CONTA         VARCHAR(20);
  DECLARE @V_CDHISTPADR    VARCHAR(04);
  DECLARE @V_COUNTPART     INT;
  DECLARE @V_ACUM          VARCHAR(01);
  DECLARE @V_COUNT         INT;
  DECLARE @V_STDATA        VARCHAR(06);

   /* VARIAVEIS DO CURSOR ITTRANSF */
  DECLARE @ITTRANSF_CDREDUCONT   VARCHAR(03);
  DECLARE @ITTRANSF_IDMOVITBANC  VARCHAR(01);
  DECLARE @ITTRANSF_VRMOVITBANC  DOUBLE PRECISION;

BEGIN
   SET @V_NRLANCTEMP    = @P_NRLANCCTBTEMP;
   SET @V_DTLANCCTBTEMP = @P_DATA;

   IF @P_NRLANCCTBTEMP IS NOT NULL BEGIN
      /* DELETE RESPONSVEL POR DELETAR OS LANAMENTOS NA LANCCONT COM O MESMO SEQUENCIAL DO LANAMENTO NO BCO, POSTERIORMENTE IR RECONTABILIZAR O MESMO */
      DELETE
        FROM LANCCCUSTO
       WHERE NRLANCCONT = @P_NRLANCCTBTEMP
         AND CDEMPRESA  = @P_CDEMPRESA;
      DELETE
        FROM LANCCONT
       WHERE NRLANCCONT = @P_NRLANCCTBTEMP
         AND CDEMPRESA  = @P_CDEMPRESA;
   END;

   SELECT @V_COUNT = COUNT(*)
     FROM PARAMCTBL
    WHERE @V_DTLANCCTBTEMP >= DTINTCTBBCO;

    IF @V_COUNT > 0 BEGIN

      DELETE
        FROM ERROCTBTEMP
       WHERE CDEMPRESA     = @P_CDEMPRESA
         AND NRLANCCTBTEMP = @P_NRLANCCTBTEMP;

      DELETE
        FROM LANCCTBTEMP
       WHERE CDEMPRESA     = @P_CDEMPRESA
         AND NRLANCCTBTEMP = @P_NRLANCCTBTEMP;

      DELETE
        FROM RATECTBTEMP
       WHERE CDEMPRESA     = @P_CDEMPRESA
         AND NRLANCCTBTEMP = @P_NRLANCCTBTEMP;

      SELECT @V_CDHISTPADR = CDHISTPADR
        FROM HISTINTEGRA
       WHERE CDOPERACAO = 'TRANSF';

       SELECT @V_ACUM = IDACUMVRCONT
         FROM CONTOPECTBL
        WHERE CDEMPRESA = @P_CDEMPRESA;

      EXEC CTB_HIST_BCO '', @P_NRTRANBANC, @V_CDHISTPADR, @P_CDEMPRESA, 'T', @P_STDSHISTPADR = @V_DSHISTLANC OUTPUT;

      IF @V_NRLANCTEMP IS NULL BEGIN
      /* PEGA UM NOVO NMERO DE LANAMENTO CONTBIL, CASO O LANAMENTO NO BCO SEJA NOVO */
         SET @V_STDATA = 'LANCCONTABIL' + @P_CDEMPRESA + CONVERT(VARCHAR, YEAR(@V_DTLANCCTBTEMP)) + CONVERT(VARCHAR, MONTH(@V_DTLANCCTBTEMP));
         EXEC NOVO_CODIGO @V_STDATA, @V_NRLANCTEMP OUTPUT;
         SET @V_NRLANCTEMP = SUBSTRING(@V_NRLANCTEMP, 9, 12);
      END;

      SET @V_PARTIDA = 1;

      DECLARE ITTRANSF CURSOR FOR
         SELECT I.CDREDUCONT, I.IDMOVITBANC, I.VRMOVITBANC
           FROM ITTRANSFBANC I, CONTCORR C,  BANCO B
          WHERE I.CDEMPRESA  = @P_CDEMPRESA  AND
                I.NRTRANBANC = @P_NRTRANBANC AND
                I.CDREDUCONT = C.CDREDUCONT  AND
                C.CDBANCO    = B.CDBANCO;
      OPEN ITTRANSF;
      FETCH NEXT FROM ITTRANSF INTO @ITTRANSF_CDREDUCONT, @ITTRANSF_IDMOVITBANC, @ITTRANSF_VRMOVITBANC;
      WHILE @@FETCH_STATUS = 0 BEGIN

         SELECT @V_CONTA = C.CDCONTCTBL
           FROM CONTCORR C, BANCO B
          WHERE C.CDBANCO  = B.CDBANCO
            AND CDREDUCONT = @ITTRANSF_CDREDUCONT
            AND CDEMPRESA  = @P_CDEMPRESA;

         /* VERIFICA SE J EXISTE LANAMENTO PARA A CONTA CONTBIL, SE EXISTIR, O SISTEMA UTILIZAR OU NO O PARAMETRO
            DE ACUMULAR VALOR NOS LANAMENTOS DE INTEGRAO, DA TELA PARMETRO CONTBIL */
         SELECT @V_COUNTPART = COUNT(*)
           FROM LANCCTBTEMP
          WHERE CDEMPRESA     = @P_CDEMPRESA
            AND NRLANCCTBTEMP = @V_NRLANCTEMP
            AND CDCONTCTBL    = @V_CONTA;

         /*PARTIDA DE DBTO*/
         IF @ITTRANSF_IDMOVITBANC = 'C' BEGIN
            IF @V_ACUM = 'N' BEGIN
               INSERT INTO LANCCTBTEMP
                  (CDEMPRESA,  NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR, DSHISTCTB, DTLANCCTBTEMP,
                   VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, CDDOCUTEMP, NRLANCCTBTEMP, IDSISTEMA)
               VALUES
                  (@P_CDEMPRESA, RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_PARTIDA), 5), @V_CONTA, @V_CDHISTPADR, @V_DSHISTLANC, @V_DTLANCCTBTEMP,
                   @ITTRANSF_VRMOVITBANC * -1, 'B', @ITTRANSF_CDREDUCONT, @P_NRTRANBANC, @V_NRLANCTEMP, 'BCO');
            END
            ELSE BEGIN
               IF @V_COUNTPART = 0 BEGIN
                  INSERT INTO LANCCTBTEMP
                     (CDEMPRESA,  NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR, DSHISTCTB, DTLANCCTBTEMP,
                      VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, CDDOCUTEMP, NRLANCCTBTEMP, IDSISTEMA)
                  VALUES
                     (@P_CDEMPRESA, RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_PARTIDA), 5), @V_CONTA, @V_CDHISTPADR, @V_DSHISTLANC, @V_DTLANCCTBTEMP,
                      @ITTRANSF_VRMOVITBANC * -1, 'B', @ITTRANSF_CDREDUCONT, @P_NRTRANBANC, @V_NRLANCTEMP, 'BCO');
               END
               ELSE BEGIN
                  UPDATE LANCCTBTEMP
                     SET VRLANCCTBTEMP = VRLANCCTBTEMP + @ITTRANSF_VRMOVITBANC * -1
                   WHERE CDEMPRESA     = @P_CDEMPRESA
                     AND NRLANCCTBTEMP = @V_NRLANCTEMP
                     AND CDCONTCTBL    = @V_CONTA;
               END;
            END;
         END
         ELSE BEGIN
            /* PARTIDA DE CRDITO */
            IF @V_ACUM = 'N' BEGIN
               INSERT INTO LANCCTBTEMP
                  (CDEMPRESA,  NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR, DSHISTCTB, DTLANCCTBTEMP,
                   VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, CDDOCUTEMP, NRLANCCTBTEMP, IDSISTEMA)
               VALUES
                  (@P_CDEMPRESA, RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_PARTIDA), 5), @V_CONTA, @V_CDHISTPADR, @V_DSHISTLANC, @V_DTLANCCTBTEMP,
                   @ITTRANSF_VRMOVITBANC, 'B', @ITTRANSF_CDREDUCONT, @P_NRTRANBANC, @V_NRLANCTEMP, 'BCO');
            END
            ELSE BEGIN
               IF @V_COUNTPART = 0 BEGIN
                  INSERT INTO LANCCTBTEMP
                     (CDEMPRESA,  NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR, DSHISTCTB, DTLANCCTBTEMP,
                      VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, CDDOCUTEMP, NRLANCCTBTEMP, IDSISTEMA)
                  VALUES
                     (@P_CDEMPRESA, RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_PARTIDA), 5), @V_CONTA, @V_CDHISTPADR, @V_DSHISTLANC, @V_DTLANCCTBTEMP,
                      @ITTRANSF_VRMOVITBANC, 'B', @ITTRANSF_CDREDUCONT, @P_NRTRANBANC, @V_NRLANCTEMP, 'BCO');
               END
               ELSE BEGIN
                  UPDATE LANCCTBTEMP
                     SET VRLANCCTBTEMP = VRLANCCTBTEMP + @ITTRANSF_VRMOVITBANC
                   WHERE CDEMPRESA     = @P_CDEMPRESA
                     AND NRLANCCTBTEMP = @V_NRLANCTEMP
                     AND CDCONTCTBL    = @V_CONTA;
               END;
            END;
         END;
         SET @V_PARTIDA = @V_PARTIDA + 1;
         FETCH NEXT FROM ITTRANSF INTO @ITTRANSF_CDREDUCONT, @ITTRANSF_IDMOVITBANC, @ITTRANSF_VRMOVITBANC;
      END;
      CLOSE ITTRANSF;
      DEALLOCATE ITTRANSF;

      IF @P_NRLANCCTBTEMP IS NULL BEGIN
         UPDATE TRANSFBANC
            SET NRLCTBTRAN = @V_NRLANCTEMP
          WHERE CDEMPRESA  = @P_CDEMPRESA
            AND NRTRANBANC = @P_NRTRANBANC;
      END;

      /*VERIFICACAO DE ERROS NAS PARTIDAS E NO LANCAMENTO CONTABIL*/
      EXEC VERIFICA_ERRO_CTB @V_NRLANCTEMP, @P_CDEMPRESA;

      /* GRAVA O LANAMENTO TEMPORRIO SE NO CONTER ERRO NA LANCCONT E LANCCUSTO, APS GRAVAR IR APAGAR O LANCAMENTO TEMPORRIO */
      EXEC GRAVA_LANC_CTB @V_NRLANCTEMP, @P_CDEMPRESA;

      SET @P_NRLANCCTB = @V_NRLANCTEMP;
   END;
END;
GO


-- VERSAO --
EXEC TEKNISA.ATUVEROBJ 'CTB_BCO_TRANSF','5.50.000';
GO

