var Fis97000_dctf_Controller = function(General, ScreenService, templateManager, Messages_fiscal, ObrigacoesAcessoriasUtil, ZHPromise) {

    // Armazena o escopo atual.
    var self = this;

    this.exportar = function(widget) {
            // Verifica se todos os campos obrigatórios foram preenchidos.
            if (widget.isValid()) {
    
                // Atribui aos fields da widget principal, os vaores da widget
                // 'parametrosGeraidDacAl'
                var DCTF = templateManager.container.getWidget('FED_DCTF');
                var parametrosWidget = templateManager.container.getWidget('parametrosGeraisDCTF');
                parametrosWidget.currentRow.CDEMPRESA = DCTF.currentRow.CDEMPRESA;
                parametrosWidget.currentRow.DTREFINI = DCTF.currentRow.DTREFINI;
                parametrosWidget.currentRow.NMARQUIVO = DCTF.currentRow.NMARQUIVO;
                parametrosWidget.currentRow.NRORG = getLocalVar('NRORG');
                preencheFieldsOcultosWidgetPrincipal(widget, parametrosWidget);
                var row = parametrosWidget.currentRow;            
                var route = "fis#/exportarDCTF";
                var message = Messages_fiscal.EXPORTANDO_DIRF;
                ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };
    
    var preencheFieldsOcultosWidgetPrincipal = function(widget, parametrosWidget){
        widget.currentRow.CDTPDECLARACAO = parametrosWidget.currentRow.CDTPDECLARACAO;
        widget.currentRow.NUMRECIBO = parametrosWidget.currentRow.NUMRECIBO; 
        widget.currentRow.CDNATDECLARANTE = parametrosWidget.currentRow.CDNATDECLARANTE;
        widget.currentRow.CDINDSOCIO = parametrosWidget.currentRow.CDINDSOCIO;
        widget.currentRow.CDDEPOSITCRED = parametrosWidget.currentRow.CDDEPOSITCRED; 
        widget.currentRow.CDTPINVEST = parametrosWidget.currentRow.CDTPINVEST; 
        widget.currentRow.CDRENDPGEXT = parametrosWidget.currentRow.CDRENDPGEXT; 
        widget.currentRow.CDINDPLANSD = parametrosWidget.currentRow.CDINDPLANSD; 
        widget.currentRow.CDPGIMUISE = parametrosWidget.currentRow.CDPGIMUISE; 
        widget.currentRow.CDFUNPUBDIRPRIV = parametrosWidget.currentRow.CDFUNPUBDIRPRIV; 
        widget.currentRow.CDSITESP = parametrosWidget.currentRow.CDSITESP; 
        widget.currentRow.DTEVENTO = parametrosWidget.currentRow.DTEVENTO; 
        widget.currentRow.CDREPRES = parametrosWidget.currentRow.CDREPRES;       
    }; 
    
    /*
     * Função para abrir o formulário com as parametrizações do DAC-AL.
     * Altera o parâmetro "wasLoaded" da widget, que indica se a parametrização
     * foi revisada antes do arquivo ter sido exportado.
     */
    var openTabParametrosGerais = function(widget) {
        
        // Seleciona a widget conforme o arquivo selecionado.
        var parametrosWidget = templateManager.container.getWidget('parametrosGeraisDCTF');
        // Recarrega os dados parametrizados.
        parametrosWidget.reload().then(function() {
            // Redesenha a widget, fazendo com que apareçam os dados carregados.
            parametrosWidget.redraw();
        });
        // Abre a widget da tabbed 'parametrosGerais'
        widget.currentWidget = parametrosWidget;
        parametrosWidget.activate();
    };
    
    /*
     * Função que habilita ou desabilita Parametros de acordo com preenchimento de empresa e nome do arquivo
     */
    this.habilitaParametros = function(dctfWidget) {
        var empresaIsSelected = !!dctfWidget.currentRow.CDEMPRESA;
        var nomeIsSelected = !!dctfWidget.currentRow.NMARQUIVO;
        var parametrosWidget = templateManager.container.getWidget("parametrosGeraisDCTF");
        
        parametrosWidget.enabled = empresaIsSelected && nomeIsSelected;
        
        if(parametrosWidget.enabled == true){
            parametrosWidget.reload();
        }
    };
    
    /*
     * Função que habilita ou desabilita Número do Recibo de acordo com preenchimento do tipo de declaração
     */
    this.controlaNmrRecibo = function(parametrosWidget) {
        var reciboField = parametrosWidget.getField("STRCBANT");
        
        if(parametrosWidget.currentRow.STTPDECLARE == 1){
            reciboField.readOnly = false;
            reciboField.validations = { required: true };
        } else if (parametrosWidget.currentRow.STTPDECLARE == 0){
            reciboField.readOnly = true;
            reciboField.validations = {};
            parametrosWidget.currentRow.STRCBANT = "";
        }
        
    };
    
    this.save = function(parametrosWidget){
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if(parametrosWidget.isValid()){
            var dctfWidget = templateManager.container.getWidget('FED_DCTF');
            preencherCamposAbstratosParaSalvar(parametrosWidget);
            
            var filter = [
                {
                    "name": "P_CDEMPRESA",
                    "operator": "=",
                    "value": dctfWidget.currentRow.CDEMPRESA
                },
            ];
            
            General.callRestEngine('fis_acessorias#/crud/paramdeclaces_Dctf', 'FilterData', filter).then(function (result) {
                result = result.dataset.paramdeclaces_Dctf;
                
                if(result.length != 0)
                    parametrosWidget.currentRow.__is_new = false;
                    
                parametrosWidget.saveRow()
                .then(function(){
                    // Seta os parametros como verificados pelo usuário
                    setParametersVerified(parametrosWidget);
                    // Ativa a widget principal
                    dctfWidget.activate();
                    dctfWidget.currentWidget = dctfWidget;
                    /**
                     * Verifica se a tela de parâmetros foi exibida devido a uma tentativa
                     * de exportação. Caso positivo, a exportação é efetuada
                     */
                    if(parametrosWidget.parametersRequired){
                        self.exportar(dctfWidget);
                        // Valida a propriedade para false, caso a tela de parametros seja
                        // novamente aberta. E assim não haverá exportação sempre ao sair
                        parametrosWidget.parametersRequired = false;
                    }
                });
            });
        }
    };
        var preencherCamposAbstratosParaSalvar = function(parametrosWidget){
        var dctfWidget = templateManager.container.getWidget('FED_DCTF');
        parametrosWidget.currentRow.CDCAMPO1    = parametrosWidget.currentRow.STTPDECLARE;
        parametrosWidget.currentRow.CDCAMPO2    = parametrosWidget.currentRow.STRCBANT;
        parametrosWidget.currentRow.CDCAMPO3    = parametrosWidget.currentRow.STSITUACAO;
        parametrosWidget.currentRow.CDCAMPO4    = parametrosWidget.currentRow.CDNATUJURI;
        parametrosWidget.currentRow.CDCAMPO5    = parametrosWidget.currentRow.CDCONTADOR2;
        parametrosWidget.currentRow.CDCAMPO6    = parametrosWidget.currentRow.STBLCRED;
        parametrosWidget.currentRow.CDCAMPO7    = parametrosWidget.currentRow.STDBTQTA;
        parametrosWidget.currentRow.CDCAMPO8   = parametrosWidget.currentRow.STVERSAO;
        parametrosWidget.currentRow.CDCAMPO9   = parametrosWidget.currentRow.STTRIBLUC;
        parametrosWidget.currentRow.CDCAMPO10    = parametrosWidget.currentRow.STPESJUR;
        parametrosWidget.currentRow.CDCAMPO23   = parametrosWidget.currentRow.STPJBLC;
        parametrosWidget.currentRow.CDCAMPO24   = parametrosWidget.currentRow.STPJSCP;
        parametrosWidget.currentRow.CDCAMPO27   = parametrosWidget.currentRow.STCRTESCRITUR;
        parametrosWidget.currentRow.CDCAMPO28   = parametrosWidget.currentRow.STREGAPUR;
        parametrosWidget.currentRow.CDCAMPO30   = parametrosWidget.currentRow.DSNATUJURI;
        parametrosWidget.currentRow.CDCAMPO31   = parametrosWidget.currentRow.NMCONTADOR;
        parametrosWidget.currentRow.CDCAMPO32   = parametrosWidget.currentRow.STPJCPRB;
        parametrosWidget.currentRow.CDCAMPO33   = parametrosWidget.currentRow.STSITUPJ;
        parametrosWidget.currentRow.CDCAMPO34   = parametrosWidget.currentRow.STOPLEI;
        parametrosWidget.currentRow.CDCAMPO35   = parametrosWidget.currentRow.PJINATIVA;
    };
    
    /**
    *Antiga funçao de salvamento
    */
    // this.save = function(widget){
    //     if(widget.isValid()){
    //         // Seleciona a widget conforme o arquivo selecionado.
    //         var DCTF = templateManager.container.getWidget('FED_DCTF');
    //         var parametrosWidget = templateManager.container.getWidget('parametrosGeraisDCTF');
    //         parametrosWidget.currentRow.CDEMPRESA = DCTF.currentRow.CDEMPRESA;
    //         parametrosWidget.currentRow.DTREFINI = DCTF.currentRow.DTREFINI;
    //         parametrosWidget.currentRow.NMARQUIVO = DCTF.currentRow.NMARQUIVO;
    //         parametrosWidget.currentRow.NRORG = getLocalVar('NRORG');
    //         General.callRestEngine('fis_acessorias#/saveDCTF','Row', widget.currentRow).then(
    //             function(success){
    //                 General.changeWidgetAcessibility(widget.widgets, true);
    //                 DCTF.activate();
    //                 DCTF.currentWidget = DCTF;
    //                 widget.reload();
    //             },
    //             function(error){
    //                 ScreenService.showMessage(error.data.error);
    //             }
    //         );
    //     }
    // };
    
     this.setLoadedParameters = function(parametrosWidget) {
        var widget = templateManager.container.getWidget("FED_DCTF");
        var widgetParametrosGeraisDCTF = templateManager.container.getWidget("parametrosGeraisDCTF");
        
        // Verifica se há alguma parametrização retornada.
        if (widgetParametrosGeraisDCTF.dataSource.data.length > 0) {
            // Seta a currentRow como o primeiro dado no array retornado.
            widgetParametrosGeraisDCTF.moveToFirst();
    
        }
        else {
            // Seta a widget em modo de novo dado, para inserir a parametrização.
            widgetParametrosGeraisDCTF.newRow();
            widgetParametrosGeraisDCTF.currentRow.CDEMPRESA = widget.currentRow.CDEMPRESA;
        }

        // Seta o nome da empresa no campo select de empresa, devido a um
        // comportamento que não exibe o nome da empresa correspondente ao código.
        widgetParametrosGeraisDCTF.currentRow.NMEMPRESA = widget.currentRow.NMEMPRESA;

    };
    
     this.beforeExitParametrosGerais = function(parametrosWidget) {
        // Seta a parametrização como verificada somente se a widget não
        // estiver em modo de inserção, mas sim de edição.
        if(parametrosWidget){
            if (!parametrosWidget.isNewRow()) {
                setParametersVerified(parametrosWidget);
            }
        }
    };
    
    var setParametersVerified = function(parametrosWidget) {
        var DCTFFiscalIsSelected = parametrosWidget.name == "parametrosGeraisDCTF";
        var currentRow = parametrosWidget.currentRow;
        // Seta a propriedade que indica se a parametrização foi verificada.
        if (DCTFFiscalIsSelected) {
            var dctfWidget = templateManager.container.getWidget("FED_DCTF");
            // Verifica se o objeto já foi criado pra esta empresa.
            if (!parametrosWidget.empresasLoaded[currentRow.CDEMPRESA]) {
                parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = {};
            }
            // Seta o parâmetro para a empresa  selecionados.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
            //dctfWidget.currentRow.REG1400 = (Array.isArray(currentRow.CDOBRIGARRAY) && currentRow.CDOBRIGARRAY.indexOf(4) !== -1);
        }
        else {
            // Modifica a propriedade indicando que a parametrização foi
            // aberta para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        }
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Fis97000_dctf_Controller', Fis97000_dctf_Controller);
});
