function WaiterTableController($scope, templateManager, ScreenService) {

	$scope.roomField = $scope.widget.fields[0];

	$scope.tableField = $scope.widget.fields[1];

	var imagePath = "bower_components/zeedhi-frontend/assets/images/icons/{0}.svg";

	$scope.__getFilter = function () {
		var filter = {};
		if ($scope.searchList) {
			filter[$scope.tableField.filterProp] = $scope.searchList;
			$scope._strict_ = false;
		} else if ($scope.roomField.currentRow) {
			filter[$scope.tableField.categoryProp] = $scope.roomField.currentRow[$scope.tableField.categoryProp];
			$scope._strict_ = true;
		}
		return filter;
	};

	$scope.nextRoom = function () {

		var dataSource = $scope.roomField.dataSource;
		var currentIndex = dataSource.data.indexOf($scope.roomField.currentRow);
		var length = dataSource.data.length;

		var nextIndex = currentIndex === length - 1 ? 0 : currentIndex + 1;

		$scope.roomField.currentRow = dataSource.data[nextIndex];
	};

	$scope.prevRoom = function () {

		var dataSource = $scope.roomField.dataSource;
		var currentIndex = dataSource.data.indexOf($scope.roomField.currentRow);
		var length = dataSource.data.length;

		var nextIndex = currentIndex === 0 ? length - 1 : currentIndex - 1;

		$scope.roomField.currentRow = dataSource.data[nextIndex];
	};
	$scope.enableTableActions = function (row, data) {
		row._showActions = !row._showActions;
		data.forEach(function (item) {
			if (item != row) {
				item._showActions = false;
			}
		});
		$scope.tableField.widget.currentRow = row;

	};
	$scope.openPopup = function () {
		ScreenService.openPopup($scope.widget.widgets[0]);
	};

	$scope.getImage = function (src) {
		src = !!src ? src : 'empty';
		return imagePath.replace("{0}", src);
	};

	$scope.openTable = function (table) {
		if ($scope.$parent.fireClickEvent === undefined) {
			$scope.$parent.fireClickEvent = true;
		}

		if ($scope.$parent.fireClickEvent) {
			$scope.tableField.widget.setCurrentRow(table);
		}
	};

}
